<?php
// vCard read only.
function abcfsl_mbox_item_VCARDHL( $tplateOptns, $itemOptns, $F, $showField ){

    if($showField == 0) { return ''; }

    if( !abcfsl_util_vcard_plugin_installed() ) {         
        //vCard plugin not installed
        $cls = 'abcflFontWP abcflFontS18 abcflFontW600 abcflMTop10 abcflRed';
        echo abcfl_input_sec_title( abcfsl_txta(416), $cls );
        return '';         
    }

    //echo"<pre>", print_r( $tplateOptns, true ), "</pre>";

    $vcTplateID = isset( $tplateOptns['_vcTplateID_' . $F] ) ? $tplateOptns['_vcTplateID_' . $F][0] : '';
    $inputLbl = isset( $tplateOptns['_inputLbl_' . $F] ) ? esc_attr( $tplateOptns['_inputLbl_' . $F][0] ) : '';
    $staticLbl = isset( $tplateOptns['_lblTxt_' . $F] ) ? esc_attr( $tplateOptns['_lblTxt_' . $F][0] ) : '';
    $slTplateID = isset( $tplateOptns['slTplateID'] ) ? $tplateOptns['slTplateID'] : 0;
    //-----------------------------------------------------------------
    $lbl = abcfsl_mbox_item_vcard_lbl( $vcTplateID, $F, $inputLbl, $slTplateID );
    $hlpTxt = abcfsl_util_vcard_no_tplate( $vcTplateID, 'VC', $slTplateID );
    echo abcfl_input_txt_readonly('ro_vcTplateName_' . $F, '', $staticLbl, $lbl, $hlpTxt, '100%', '', '', 'abcflFldCntr', 'abcflFldLbl', 'abcflRed');
    
}

//F label
function abcfsl_mbox_item_vcard_lbl( $vcTplateID, $F, $inputLbl, $slTplateID ){

    $cbo = abcfsl_db_cbo_vcard_tplates( $slTplateID, 'VC' );
    if ( array_key_exists( $vcTplateID, $cbo ) ) {
        $inputLbl = $inputLbl . ' - ' . $cbo[$vcTplateID];
    }

    return abcfsl_mbox_item_text_line_number( $F , $inputLbl );
}

//==== QRHLIMGSTA ==========================================================
function abcfsl_mbox_item_QRHLIMGSTA( $tplateOptns, $itemOptns, $F, $showField ){

    if( $showField == 0 )  { return ''; }

    //-- Displays error message instead of field input.
    if( !abcfsl_util_vcard_plugin_installed() ) {         
        //vCard plugin not installed
        $cls = 'abcflFontWP abcflFontS18 abcflFontW600 abcflMTop10 abcflRed';
        echo abcfl_input_sec_title( abcfsl_txta(416), $cls );
        return '';         
    }
    //======================================================================
    //$vcTplateID = isset( $tplateOptns['_vcTplateID_' . $F] ) ? $tplateOptns['_vcTplateID_' . $F][0] : '';
    $vcUploadDir = isset( $tplateOptns['_vcUploadDir_' . $F] ) ?  $tplateOptns['_vcUploadDir_' . $F][0] : '';
    $vcUploadUrl = isset( $tplateOptns['_vcUploadUrl_' . $F] ) ?  $tplateOptns['_vcUploadUrl_' . $F][0] : '';
    $inputLbl = isset( $tplateOptns['_inputLbl_' . $F] ) ? esc_attr( $tplateOptns['_inputLbl_' . $F][0] ) : '';
    $staticLbl = isset( $tplateOptns['_lblTxt_' . $F] ) ? esc_attr( $tplateOptns['_lblTxt_' . $F][0] ) : '';
    $slTplateID = isset( $tplateOptns['slTplateID'] ) ? $tplateOptns['slTplateID'] : 0;

    //echo"<pre>", print_r( $itemOptns, true ), "</pre>"; 
    //================================================================================
    $saveQrErrorTxt = isset( $itemOptns['_qrErrorTxt_' . $F] ) ? esc_attr( $itemOptns['_qrErrorTxt_' . $F][0] ) : '';
    $staffID = isset( $itemOptns['staffID'] ) ? $itemOptns['staffID'] : 0;

    $params['staffID'] = $staffID;
    $params['F'] = $F;
    $params['slTplateID'] = $slTplateID;

    $qrImgBuilder = new ABCFSL_QR_Img_Builder( $params ); 
    // Check for errors only. Image is created on post save: abcfl_mbsave_create_qr_code_img
    $qrImgBuilder->checkForErrorsPNGImg(); 

    $errTxt = $qrImgBuilder->getErrTxt();
    $qrImgUrl = $qrImgBuilder->getImgUrl();
    $qrFileQPath = $qrImgBuilder->getFileQPath();
    $imgBuilderUploadDir = $qrImgBuilder->getUploadDir();  
    $imgBuilderUploadUrl = $qrImgBuilder->getUploadUrl();  

    //== Field lbl + Help under =====================================
    $lbl = abcfsl_mbox_item_text_line_number( $F , $inputLbl );

    $hlpUnder = $qrFileQPath;
    $hlpUnderCls = '';
    $errMsg = '';

    if( !empty( $saveQrErrorTxt ) ) {
        $errMsg = $saveQrErrorTxt . ' ';
    }

    if( !empty( $errTxt ) ) {
        if( $saveQrErrorTxt != $errTxt ) {
            $errMsg = $errMsg . $errTxt . ' ';
        }        
    }

    if( $vcUploadDir != $imgBuilderUploadDir ) {
        if( !empty( $imgBuilderUploadDir ) ) {
            $errMsg = $errMsg . 'Diectores do not match. ';
        }
    }

    if( $vcUploadUrl != $imgBuilderUploadUrl ) { 
        if( !empty( $imgBuilderUploadUrl ) ) {
            $errMsg = $errMsg . 'Image URLs do not match. ';
        }        
    }

    if( !empty( $errMsg ) ) {
        $hlpUnder = $errMsg;
        $hlpUnderCls = 'abcflRed';
    }

    //---Field container (image + read only hyperlink static text -------------------
    $aTag = '';
    if( !empty( $qrImgUrl ) ) {
        $imgTag = abcfl_html_img_tag_resp( '', $qrImgUrl, '', '', 'abcfFTypeImg' );
        $aTag = abcfl_html_a_tag_img( $qrImgUrl, $imgTag, '_blank', '', '', '', '' );
    }

    $hLinkTxt = abcfl_input_txt_readonly('ro_qrHlTxtImgSta_' . $F, '', $staticLbl, $lbl, $hlpUnder, '100%', '', '', 'abcflFldCntr', 'abcflFldLbl', $hlpUnderCls);

    //--------------------------------------------------
    $flexCntrS = abcfl_html_tag( 'div', '', 'abcflFGCntrStart' );   
    $flexImg = abcfl_html_tag( 'div', '', 'abcflFG10P' );
    $flexHLinkTxt = abcfl_html_tag( 'div', '', 'abcflFG90P' );
    $divE = abcfl_html_tag_end( 'div');

    echo $flexCntrS . $flexImg . $aTag . $divE . $flexHLinkTxt . $hLinkTxt . abcfl_html_tag_ends( 'div,div');
    
}

function abcfsl_mbox_item_QRHL64STA( $tplateOptns, $itemOptns, $F, $showField ){

    if( $showField == 0 )  { return ''; }

    //-- Displays error message instead of field input.
    if( !abcfsl_util_vcard_plugin_installed() ) {         
        //vCard plugin not installed
        $cls = 'abcflFontWP abcflFontS18 abcflFontW600 abcflMTop10 abcflRed';
        echo abcfl_input_sec_title( abcfsl_txta(416), $cls );
        return '';         
    }
    //======================================================================
    //$vcTplateID = isset( $tplateOptns['_vcTplateID_' . $F] ) ? $tplateOptns['_vcTplateID_' . $F][0] : '';
    $inputLbl = isset( $tplateOptns['_inputLbl_' . $F] ) ? esc_attr( $tplateOptns['_inputLbl_' . $F][0] ) : '';
    $staticLbl = isset( $tplateOptns['_lblTxt_' . $F] ) ? esc_attr( $tplateOptns['_lblTxt_' . $F][0] ) : '';
    //$slTplateID = isset( $tplateOptns['slTplateID'] ) ? $tplateOptns['slTplateID'] : 0;
    //================================================================================
    $qrImgUri = isset( $itemOptns['_qrImgUri_' . $F] ) ? esc_attr( $itemOptns['_qrImgUri_' . $F][0] ) : '';
    $saveQrErrorTxt = isset( $itemOptns['_qrErrorTxt_' . $F] ) ? esc_attr( $itemOptns['_qrErrorTxt_' . $F][0] ) : '';
    $staffID = isset( $itemOptns['staffID'] ) ? $itemOptns['staffID'] : 0;

    //== Field lbl + Help under =====================================
    $lbl = abcfsl_mbox_item_text_line_number( $F, $inputLbl );
    $lblBase64 = abcfsl_mbox_item_text_line_number( $F, 'Image Base64' );

    $hlpUnder = '';
    $hlpUnderCls = '';
    $errMsg = '';

    if( !empty( $saveQrErrorTxt ) ) {
        $errMsg = $saveQrErrorTxt . ' ';
    }

    if( !empty( $errMsg ) ) {
        $hlpUnder = $errMsg;
        $hlpUnderCls = 'abcflRed';
    }

    //---Field container (image + read only hyperlink static text -------------------
    //// Takes data 64 as href. href="data:image/png;base64,iVBO....
    //$aTag = abcfl_html_a_tag_data( $href, $lnkTxt, $target='', $cls='', $onclickJS='', $args='' )

    $aTag = '';
    if( !empty( $qrImgUri ) ) {
        $imgTag64 = abcfl_html_img_tag_resp( '', $qrImgUri, '', '', 'abcfFTypeImg' );
        $aTag = abcfl_html_a_tag_data( $qrImgUri, $imgTag64, '_blank' );

    //<a href="http://localhost:8080/blog/wp-content/uploads/qrcode_6854_23.png">
    //<img src="http://localhost:8080/blog/wp-content/uploads/qrcode_6854_23.png" class="abcfFTypeImg" alt="" itemprop="image">
    //</a>     
    }

    $hLinkTxt = abcfl_input_txt_readonly('ro_qrHlTxt64Sta_' . $F, '', $staticLbl, $lbl, $hlpUnder, '100%', '', '', 'abcflFldCntr', 'abcflFldLbl', $hlpUnderCls);
    $img64 = abcfl_input_txt_readonly('qrImg64_' . $F, '', $qrImgUri, $lblBase64, '', '100%', '', '', 'abcflFldCntr', 'abcflFldLbl', $hlpUnderCls);

    //--------------------------------------------------
    $flexCntrS = abcfl_html_tag( 'div', '', 'abcflFGCntrStart' );   
    $flexImg = abcfl_html_tag( 'div', '', 'abcflFG10P' );
    $flexHLinkTxt = abcfl_html_tag( 'div', '', 'abcflFG30P' );
    $flexImg64 = abcfl_html_tag( 'div', '', 'abcflFG60P abcflPLeft5' );
    $divE = abcfl_html_tag_end( 'div');

    echo $flexCntrS . $flexImg . $aTag . $divE . $flexHLinkTxt . $hLinkTxt . $divE . $flexImg64 . $img64 . abcfl_html_tag_ends( 'div,div');
}

function abcfsl_mbox_item_QRHL64DYN( $tplateOptns, $itemOptns, $F, $showField ){

    //echo"<pre>", print_r( $itemOptns, true ), "</pre>";

    if( $showField == 0 )  { return ''; }

    //-- Displays error message instead of field input.
    if( !abcfsl_util_vcard_plugin_installed() ) {         
        //vCard plugin not installed
        $cls = 'abcflFontWP abcflFontS18 abcflFontW600 abcflMTop10 abcflRed';
        echo abcfl_input_sec_title( abcfsl_txta(416), $cls );
        return '';         
    }
    //======================================================================
    //$vcTplateID = isset( $tplateOptns['_vcTplateID_' . $F] ) ? $tplateOptns['_vcTplateID_' . $F][0] : '';
    $inputLbl = isset( $tplateOptns['_inputLbl_' . $F] ) ? esc_attr( $tplateOptns['_inputLbl_' . $F][0] ) : '';
    $staticLbl = isset( $tplateOptns['_lblTxt_' . $F] ) ? esc_attr( $tplateOptns['_lblTxt_' . $F][0] ) : '';
    $slTplateID = isset( $tplateOptns['slTplateID'] ) ? $tplateOptns['slTplateID'] : 0;

    //echo"<pre>", print_r( $vcUploadUrl, true ), "</pre>"; die;
    //================================================================================
    $saveQrErrorTxt = isset( $itemOptns['_qrErrorTxt_' . $F] ) ? esc_attr( $itemOptns['_qrErrorTxt_' . $F][0] ) : '';
    $staffID = isset( $itemOptns['staffID'] ) ? $itemOptns['staffID'] : 0;

    $params['staffID'] = $staffID;
    $params['F'] = $F;
    $params['slTplateID'] = $slTplateID;
    //$params['saveImg'] = false;  
    
    //error_log( print_r( 'ro_qrHLinkTxt_' . $F, true) );
    $qrImgBuilder = new ABCFSL_QR_Img_Builder( $params );
    $qrImgBuilder->maybeCreateQRImgUri(); 

    $errTxt = $qrImgBuilder->getErrTxt();
    $qrImgUri = $qrImgBuilder->getImgUri(); 

    //== Field lbl + Help under =====================================
    $lbl = abcfsl_mbox_item_text_line_number( $F , $inputLbl );

    $hlpUnder = '';
    $hlpUnderCls = '';
    $errMsg = '';

    if( !empty( $saveQrErrorTxt ) ) {
        $errMsg = $saveQrErrorTxt . ' ';
    }

    if( !empty( $errTxt ) ) {
        if( $saveQrErrorTxt != $errTxt ) {
            $errMsg = $errMsg . $errTxt . ' ';
        }        
    }

    if( !empty( $errMsg ) ) {
        $hlpUnder = $errMsg;
        $hlpUnderCls = 'abcflRed';
    }

    //---Field container (image + read only hyperlink static text -------------------

    //// Takes data 64 as href. href="data:image/png;base64,iVBO....
    //$aTag = abcfl_html_a_tag_data( $href, $lnkTxt, $target='', $cls='', $onclickJS='', $args='' )
    $aTag = '';
    if( !empty( $qrImgUri ) ) {
        $imgTag64 = abcfl_html_img_tag_resp( '', $qrImgUri, '', '', 'abcfFTypeImg' );
        $aTag = abcfl_html_a_tag_data( $qrImgUri, $imgTag64, '_blank' );
    }

    $hLinkTxt = abcfl_input_txt_readonly('ro_qrHlTxt64Dyn_' . $F, '', $staticLbl, $lbl, $hlpUnder, '100%', '', '', 'abcflFldCntr', 'abcflFldLbl', $hlpUnderCls);

    //--------------------------------------------------
    $flexCntrS = abcfl_html_tag( 'div', '', 'abcflFGCntrStart' );   
    $flexImg = abcfl_html_tag( 'div', '', 'abcflFG10P' );
    $flexHLinkTxt = abcfl_html_tag( 'div', '', 'abcflFG90P' );
    $divE = abcfl_html_tag_end( 'div');

    echo $flexCntrS . $flexImg . $aTag . $divE . $flexHLinkTxt . $hLinkTxt . abcfl_html_tag_ends( 'div,div');

}