<?php
// vCARD
function abcfsl_cnt_field_VCARDHL( $par, $tplateOptns, $itemOptns ){

    // vCard plugin not installed.
    if( !abcfsl_util_vcard_plugin_installed() ) { return ''; }

    $F = $par['F'];
    $staffID = $par['itemID'];

    if( empty( $staffID ) ) { return ''; }
    if( empty( $F ) ) { return ''; }

    // Check if vCard template selected.
    $vcTplateID = isset( $tplateOptns['_vcTplateID_' . $F] ) ?  $tplateOptns['_vcTplateID_' . $F][0] : 0;
    if( empty( $vcTplateID ) ) { return ''; }

    $slTplateID = isset( $tplateOptns['slTplateID'] ) ? $tplateOptns['slTplateID'] : 0;
    // Check if vCard template exists.
    $cbo = abcfsl_db_cbo_vcard_tplates( $slTplateID, 'VC' );
    if ( !array_key_exists( $vcTplateID, $cbo ) ) { return ''; }
    //========================================================
    $currentPg = abcfsl_util_get_current_url();

    //http://xxxxx/?smid=8691-7&vctid=8747&staff-cp=vcard    
    $vCardDloadURL = add_query_arg( array(
        'smid' => $staffID . '-' . substr($F, 1),
        'vctid' => $vcTplateID,
        'staff-cp' => 'vcard'
    ), $currentPg );

    $cntrS = abcfl_html_tag( $par['tagType'], '', $par['tagCls'] . $par['fieldTypeF'], $par['tagStyle'] );
    $cntrE = abcfl_html_tag_end( $par['tagType']);

    $aTag = abcfl_html_a_tag_nb( $vCardDloadURL, $par['lblTxt'], '', $par['lnkCls'], $par['lnkStyle'], '', '', '' );
    return $cntrS . $aTag . $cntrE;
}

function abcfsl_cnt_field_VCARD( $par, $tplateOptns, $itemOptns ){

    return '';
}
// QR Code
function abcfsl_cnt_field_QRHLIMGSTA( $par, $tplateOptns, $itemOptns ){

    $F = $par['F'];
    if( empty( $F ) ) { return ''; }

    $staffID = $par['itemID'];
    if( empty( $staffID ) ) { return ''; }
    //---------------------------------------------------------------
    $qrFileName = 'qrcode_' . $staffID . '_' . ltrim( $F, 'F') . '.png';

    $vcUploadDir = isset( $tplateOptns['_vcUploadDir_' . $F] ) ?  $tplateOptns['_vcUploadDir_' . $F][0] : '';
    if( empty( $vcUploadDir ) ) { return ''; }

    $vcUploadUrl = isset( $tplateOptns['_vcUploadUrl_' . $F] ) ?  $tplateOptns['_vcUploadUrl_' . $F][0] : '';
    if( empty( $vcUploadUrl ) ) { return ''; }

    $ileQPath = trailingslashit( $vcUploadDir ) . $qrFileName;
    if ( !file_exists( $ileQPath ) ) { return ''; }
    //========================================================
    $cntrS = abcfl_html_tag( $par['tagType'], '', $par['tagCls'] . $par['fieldTypeF'], $par['tagStyle'] );
    $cntrE = abcfl_html_tag_end( $par['tagType']);

    $qrImgUrl = trailingslashit( $vcUploadUrl ) . $qrFileName;

    $aTag = abcfl_html_a_tag_nb( $qrImgUrl, $par['lblTxt'], $par['lnkNT'], $par['lnkCls'], $par['lnkStyle'], '', '', '' );
    return $cntrS . $aTag . $cntrE;
}    


function abcfsl_cnt_field_QRHL64STA( $par, $tplateOptns, $itemOptns ){

    $F = $par['F'];
    if( empty( $F ) ) { return ''; }

    $staffID = $par['itemID'];
    if( empty( $staffID ) ) { return ''; }
    //---------------------------------------------------------------
    $qrImgUri = isset( $itemOptns['_qrImgUri_' . $F] ) ? esc_attr( $itemOptns['_qrImgUri_' . $F][0] ) : '';
    if( empty( $qrImgUri ) ) { return ''; }

    //========================================================
    $cntrS = abcfl_html_tag( $par['tagType'], '', $par['tagCls'] . $par['fieldTypeF'], $par['tagStyle'] );
    $cntrE = abcfl_html_tag_end( $par['tagType']);

    $aTag = abcfl_html_a_tag_data( $qrImgUri, $par['lblTxt'], $par['lnkNT'], $par['lnkCls'], $par['lnkStyle'], '', '', '' );
    return $cntrS . $aTag . $cntrE;
}

function abcfsl_cnt_field_QRHL64DYN( $par, $tplateOptns, $itemOptns ){

    //return '';
    //-- Displays error message instead of field input.
    if( !abcfsl_util_vcard_plugin_installed() ) { return ''; }

    $F = $par['F'];
    if( empty( $F ) ) { return ''; }

    $staffID = $par['itemID'];
    if( empty( $staffID ) ) { return ''; }

    $saveQrErrorTxt = isset( $itemOptns['_qrErrorTxt_' . $F] ) ? esc_attr( $itemOptns['_qrErrorTxt_' . $F][0] ) : '';
    if( !empty( $saveQrErrorTxt ) ) { return ''; }

    //-------------------------------------------------
    $vcTplateID = isset( $tplateOptns['_vcTplateID_' . $F] ) ? $tplateOptns['_vcTplateID_' . $F][0] : '';
    $slTplateID = isset( $tplateOptns['slTplateID'] ) ? $tplateOptns['slTplateID'] : 0;

    // Check if vCard template exists.
    $cbo = abcfsl_db_cbo_vcard_tplates( $slTplateID, 'QR' );
    if ( !array_key_exists( $vcTplateID, $cbo ) ) { return ''; }

    //echo"<pre>", print_r( $slTplateID, true ), "</pre>"; die;
    //================================================================================
    $params['staffID'] = $staffID;
    $params['F'] = $F;
    $params['slTplateID'] = $slTplateID;
    //$params['saveImg'] = false; 

    // //error_log( print_r( 'ro_qrHLinkTxt_' . $F, true) );
    $qrImgBuilder = new ABCFSL_QR_Img_Builder( $params ); 
    $qrImgBuilder->maybeCreateQRImgUri(); 

    $errTxt = $qrImgBuilder->getErrTxt();
    $qrImgUri = $qrImgBuilder->getImgUri(); 

    if( !empty( $errTxt ) ) { return ''; }    
    if( empty( $qrImgUri ) ) { return ''; }

    //========================================================
    $cntrS = abcfl_html_tag( $par['tagType'], '', $par['tagCls'] . $par['fieldTypeF'], $par['tagStyle'] );
    $cntrE = abcfl_html_tag_end( $par['tagType']);

    $aTag = abcfl_html_a_tag_data( $qrImgUri, $par['lblTxt'], $par['lnkNT'], $par['lnkCls'], $par['lnkStyle'], '', '', '' );
    return $cntrS . $aTag . $cntrE;
}